<?php

function delete_directory($dirname) {
	if (is_dir($dirname)){
		chmod($dirname,"0777");
		$dir_handle = opendir($dirname);
	}
	if (!$dir_handle)
	return false;
	while($file = readdir($dir_handle)) {
		if ($file != "." && $file != "..") {
			if (!is_dir($dirname."/".$file)){
				chmod($dirname."/".$file,"0777");
				unlink($dirname."/".$file);
			}else{
				delete_directory($dirname.'/'.$file);
			}
		}
	}
	closedir($dir_handle);
	rmdir($dirname);
	return true;
}
 





function ristorante_load($id){
	$ristorante = array();
	$query = "SELECT id_user, nome, comune, indirizzo, telefono, email, descrizione, menu, datains, dataagg, datascad FROM {locale} WHERE id = %d";
	$rows = db_query($query,$id);

	if($row = db_fetch_array($rows)) {
		$ristorante = $row;
	}
		

	return $ristorante;
}


function specialita_load($restaurant,$specialita){
	$data = array();
	$query = "SELECT id, locale, specialita,descrizione FROM {localespecialita} WHERE locale=%d and specialita = %d";

	$rows = db_query($query,$restaurant,$specialita);

	if($row = db_fetch_array($rows)) {
		$data = $row;
	}
		

	return $data;
}


function specialita_load_id($specialita){
	$data = array();
	$query = "SELECT id, locale, specialita,descrizione FROM {localespecialita} WHERE id = %d";

	$rows = db_query($query,$specialita);

	if($row = db_fetch_array($rows)) {
		$data = $row;
	}
		

	return $data;
}



function specialita_list($restaurant){

	$data = array();
	$query = "SELECT  l.id as id,s.nome AS nome,l.descrizione as descrizione FROM {localespecialita} l INNER JOIN {specialita} s ON l.specialita = s.id WHERE l.locale = %d";
	$rows = db_query($query,$restaurant);

	$header = array(t('Nome'),t('Descrizione'),t('Operazioni'));

	while($row = db_fetch_array($rows)) {
		$id = $row[id];
		unset($row[id]);
			
		array_push($row,l("Modifica","/restaurant/details/".$id."/edit")."&nbsp;".l("Cancella","/restaurant/details/".$id."/delete"));
			
		$data[] = $row;
	}

	$data = theme('table', $header,$data);
	return $data;
}



function ristorante_delete($id){
	$ristorante = ristorante_load($id);

	$user = $GLOBALS['user'];
	$admin = user_access('administer users');

	if(!admin && ($ristorante['id_user'] != $user)){
		drupal_access_denied();
		return;
	}

	$directory = "./".drupal_get_path('module','ristorante').'/upload/'.$id;
	if(delete_directory($directory)){
		watchdog('restaurant','Cancellata directory %name',array('%name',$directory));
	}else{
		//TODO:invio mail errore
		watchdog('restaurant','Problema nella cancellazione della directory %name',array('%name',$directory));
	}


	$sql = "delete from {localeimage} where locale = %d";
	if(! db_query($sql,$id)){
		watchdog('restaurant','Problema nella cancellazione del ristorante %name',array('%name',$ristorante['nome']));
	}

	$sql = "delete from {localespecialita} where locale = %d";
	if(! db_query($sql,$id)){
		watchdog('restaurant','Problema nella cancellazione del ristorante %name',array('%name',$ristorante['nome']));
	}

	$sql = "delete from {locale} where id = %d";

	if(db_query($sql,$id)){
		watchdog('restaurant','Cancellato ristorante %name',array('%name',$ristorante['nome']));
	}else{
		watchdog('restaurant','Problema nella cancellazione del ristorante %name',array('%name',$ristorante['nome']));
	}

	drupal_goto("restaurant/settings");
}


/**
 * Gestione delle variabili di configurazione
 */
function ristorante_admin_settings(){
	$form = array();
	$form['#cache'] = TRUE;
	$form['#submit'] = array('ristorante_admin_settings_submit');

	$form['role'] = array(
	      	'#type' => 'select',
	      	'#title' => t('Ruolo Associato'),
	    	'#options' => getRoles(),
	    	'#default_value' => variable_get('ristorante_user_role', 3),
	);
	 
	$form['theme'] = array(
	      	'#type' => 'select',
	      	'#title' => t('Tema Associato'),
	    	'#options' => getThemes(),
	    	'#default_value' => variable_get('ristorante_default_theme', 'garland'),
	);
	 
	$form['free_date'] = array(
	      	'#type' => 'textfield',
	      	'#title' => t('Inserire il numero di giorni dell\'offerta del servizio'),
	    	'#default_value' => variable_get('ristorante_default_free_date', 180),
	);
	 
	$form['buttons']['submit'] = array(
	      '#type' => 'submit',
	      '#value' => 'Salva'
	      );
	       
	      return $form;
}

function ristorante_details($ristorante = NULL){

	$rist = ristorante_load($ristorante);
	$admin = user_access('administer users');
	$user = $GLOBALS['user'];

	if(!admin && ($rist['id_user'] != $user)){
		drupal_access_denied();
		return;
	}


	$data .= drupal_get_form('ristorante_details_insert',$ristorante);
	$data .= specialita_list($ristorante);

	return $data;

}

function ristorante_data_edit($specialita = NULL){
	$row = specialita_load_id($specialita);
	$rist = ristorante_load($row['locale']);
	$admin = user_access('administer users');
	$user = $GLOBALS['user'];

	if(!admin && ($rist['id_user'] != $user)){
		drupal_access_denied();
		return;
	}

	$data .= drupal_get_form('ristorante_details_edit',$specialita);
	return $data;
}


function ristorante_details_delete($specialita = NULL){

	$row = specialita_load_id($specialita);
	$rist = ristorante_load($row['locale']);
	$admin = user_access('administer users');
	$user = $GLOBALS['user'];

	if(!admin && ($rist['id_user'] != $user)){
		drupal_access_denied();
		return;
	}

	if($specialita != NULL){
		$query = 'DELETE FROM {localespecialita} WHERE id = %d';
		db_query($query,$specialita);
	}
	drupal_goto("/restaurant/".$row['locale']."/details");

}


function ristorante_details_edit($form, $specialita = NULL){
	$form = array();
	$form['#cache'] = TRUE;


	$values = specialita_load_id($specialita);
	if($values['id'] == NULL){
		return;
	}


	$form['specialita'] = array(
			'#type'	=> 'select',
			'#options' => _list_specialita(),
			'#title'         => t('Specialit&agrave;'),
	      	'#description'   => t('Inserire la specialit&agrave; da aggiungere'),
			'#default_value' => $values['specialita'],
			'#required' => TRUE,
	      	'#maxlength'     => 10
	);

	$form['descrizione'] = array(
			'#type'	=> 'textarea',
			'#title'         => t('Descrizione'),
	      	'#description'   => t('Inserisci una desrizione'),
			'#value' => $values['descrizione'],
			'#maxlength'     => 100
	);

	$form['id'] = array(
			'#type'		=> 'hidden',
			'#maxlength'=> 100,
			'#value' => $values['id']
	);


	$form['buttons']['submit'] = array(
	      '#type' => 'submit',
	      '#value' => 'Salva'
	      );

	      return $form;
}


function ristorante_details_edit_validate($form, &$form_state){
	$admin = user_access('administer users');
	$user = $GLOBALS['user'];

	$specialita = $form_state['values']['specialita'];
	$id = $form_state['values']['id'];


	$values = specialita_load_id($id);
	$ristorante = ristorante_load($values['locale']);

	if(!admin && ($ristorante['id_user'] != $user)){
		form_set_error('', t('Non possiedi i permessi per modificare il locale.'));
	}


	$values = specialita_load($values['locale'],$specialita);

	if($values['id'] != NULL && $values['id'] != $id){
		form_set_error('specialita', t('Non puoi selezionare questo tipo di specialit&agrave; in quanto  gia presente !!'));
	}
}


function ristorante_details_edit_submit($form, &$form_state){
	$id = $form_state['values']['id'];
	$specialita = $form_state['values']['specialita'];
	$descrizione = $_POST['descrizione'];

	$query = 'UPDATE {localespecialita} SET specialita = %d WHERE id = %d';
	if(db_query($query,$specialita,$id)){
		watchdog('restaurant','Aggiornata specialit id %id',array('%id',$id));
	}

	$query = 'UPDATE {localespecialita} SET descrizione = \'%s\' WHERE id = %d';
	if(db_query($query,$descrizione,$id)){
		watchdog('restaurant','Aggiornata descrizione id %id',array('%id',$id));
	}

	$row = specialita_load_id($id);
	drupal_goto("/restaurant/".$row['locale']."/details");

}


function ristorante_details_insert($form, $ristorante = NULL){
	$form = array();
	$form['#cache'] = TRUE;

	$form['specialita'] = array(
			'#type'	=> 'select',
			'#options' => _list_specialita(),
			'#title'         => t('Specialit&agrave;'),
	      	'#description'   => t('Inserire la specialit&agrave; da aggiungere'),
			'#required' => TRUE,
	      	'#maxlength'     => 10
	);

	$form['descrizione'] = array(
			'#type'	=> 'textarea',
			'#title'         => t('Descrizione'),
	      	'#description'   => t('Inserisci una desrizione'),
			'#maxlength'     => 100
	);

	$form['ristorante'] = array(
			'#type'		=> 'hidden',
			'#maxlength'=> 100,
			'#value' => $ristorante
	);


	$form['buttons']['submit'] = array(
	      '#type' => 'submit',
	      '#value' => 'Salva'
	      );

	      return $form;
}
function ristorante_details_insert_validate($form, &$form_state){
	$admin = user_access('administer users');
	$user = $GLOBALS['user'];

	$ristorante = $form_state['values']['ristorante'];
	$ristorante = $form_state['values']['specialita'];
	$ristorante = ristorante_load($ristorante);

	//Controllo i permessi
	if(!admin && ($ristorante['id_user'] != $user)){
		form_set_error('', t('Non possiedi i permessi per modificare il locale.'));
	}


}

function ristorante_details_insert_submit($form, &$form_state){
	$locale = $form_state['values']['ristorante'];
	$specialita = $form_state['values']['specialita'];
	$descrizione = $form_state['values']['descrizione'];
		
	$value = specialita_load($locale,$specialita);


	if($value['id'] != NULL){
		$query = 'UPDATE {localespecialita} SET descrizione = \'%s\' WHERE id = %d';
		if(db_query($query,$descrizione,$value['id'])){
			watchdog('restaurant','Aggiornata specialit id %id',array('%id',$value['id']));
		}
	}else{
		$query = 'INSERT INTO {localespecialita}(locale,specialita,descrizione) VALUES (%d,%d,\'%s\')';
		if(db_query($query,$locale,$specialita,$descrizione)){
			$id = db_last_insert_id('localespecialita','id');
			watchdog('restaurant','Aggiornata specialit id %id',array('%id',$id));
		}
	}



}

function ristorante_admin_page(){
	$data .= drupal_get_form('ristorante_data_settings');

	if (isset($_SESSION['ristorante_admin_form_value'])){
		$search =  $_SESSION['ristorante_admin_form_value'];
		$nome = $search['nome'];
		$comune = $search['comune'];
		$datascadenzada = $search['datascadenzada'];
		$datascadenzaa = $search['datascadenzaa'];
		$data .= ristorante_admin_tabella($nome,$comune,$datascadenzada,$datascadenzaa);
	}else{
		$data .= ristorante_admin_tabella();
	}


	return $data;
}


function ristorante_add(){
	$data .= drupal_get_form('ristorante_data_insert');
	return $data;
}

function _list_users(){
	$options = array();
	$sql = "SELECT uid, name FROM {users}  WHERE uid != 0";
	$rows = db_query($sql);

	while ($row = db_fetch_array($rows)) {
		$options[$row['uid']] = $row['name'];
	}
	return $options;
}


function _list_specialita(){
	$options = array();
	$sql = "SELECT id, nome FROM {specialita}";
	$rows = db_query($sql);

	while ($row = db_fetch_array($rows)) {
		$options[$row['id']] = $row['nome'];
	}
	return $options;
}

function ristorante_data_insert(){
	$form = array();
	$form['#cache'] = TRUE;

	$form['#submit'] = array('ristorante_data_insert_submit');

	$admin = user_access('administer users');

	if($admin){
		$form['user'] = array(
				'#type'	=> 'select',
				'#options' => _list_users(),
				'#title'         => t('Utente associato'),
		      	'#description'   => t('Selezione l\'utente associato'),
				'#required' => TRUE,
		      	'#maxlength'     => 20
		);
	}


	$form['nome'] = array(
			'#type'	=> 'textfield',
			'#title'         => t('Nome'),
	      	'#description'   => t('Inserisci il nome del ristorante'),
			'#required' => TRUE,
	      	'#maxlength'     => 20
	);

	$form['comune'] = array(
			'#type'          => 'textfield',
      		'#title'         => t('Comune'),
      		'#description'   => t('Inserisci Comune'),
      		'#maxlength'     => 100,
    		'#attributes'    => array('class' => 'comuni-autocomplete'),
			'#required' => TRUE,
    		'#autocomplete_path' => 'ristorante/comune/autocomplete'
    		);

    		$form['indirizzo'] = array(
			'#type'	=> 'textfield',
			'#title'         => t('Indirizzo'),
	      	'#description'   => t('Inserisci l\'indirizzo del ristorante'),
			'#required' => TRUE,
	      	'#maxlength'     => 150
    		);

    		$form['telefono'] = array(
			'#type'	=> 'textfield',
			'#title'         => t('telefono'),
			'#required' => TRUE,
	      	'#description'   => t('Inserisci il recapito telefonico del ristorante'),
	      	'#maxlength'     => 30
    		);

    		$form['email'] = array(
			'#type'	=> 'textfield',
			'#title'         => t('email'),
	      	'#description'   => t('Inserisci il recapito email del ristorante'),
	      	'#maxlength'     => 30
    		);



    		$form['descrizione'] = array(
			'#type'	=> 'textarea',
			'#title'         => t('descrizione'),
			'#required' => TRUE,
	      	'#description'   => t('Inserisci la descrizione del locale')
    		);

    		$form['menu'] = array(
			'#type'	=> 'textarea',
			'#title'         => t('menu'),
	      	'#description'   => t('Inserisci una desrizione del tuo men&ugrave;')
    		);



    		$form['buttons']['submit'] = array(
	      '#type' => 'submit',
	      '#value' => 'Inserisci'
	      );

	      return $form;
}



function ristorante_data_insert_validate($form, &$form_state){
	if ($form_state['values']['email'] != '') {
		//Se ho impostato la mail controllo si valida
		if ($error = user_validate_mail($form_state['values']['email'])) {
			form_set_error('email', $error);
		}else if (drupal_is_denied('email', $form_state['values']['email'])) {
			form_set_error('email', t('La tua email : %email non &egrave stata accettata.', array('%email' =>$form_state['values']['email'])));
		}
	}

	if ($form_state['values']['telefono'] != '') {
		if(!preg_match("/[0-9]+/",$form_state['values']['telefono'])){
			form_set_error('telefono', t('Il numero di telefono inserito non &egrave; valido.'));
		}
	}


}

function ristorante_data_insert_submit($form, &$form_state){
	//inserimento del ristorante



	$user = $GLOBALS['user'];


	$userid = $form_state['values']['user'];
	$admin = user_access('administer users');

	$nome = $form_state['values']['nome'];
	$comune = $form_state['values']['comune'];
	$indirizzo = $form_state['values']['indirizzo'];
	$telefono = $form_state['values']['telefono'];
	$email = $form_state['values']['email'];
	$descrizione = $form_state['values']['descrizione'];
	$menu = $form_state['values']['menu'];


	//estraggo il codice del comune
	$sqlcomune = "SELECT id FROM {comune} WHERE comune = '%s';";
	$rows = db_query($sqlcomune,$comune);
	if($row = db_fetch_array($rows)){
		$comune = $row['id'];
	}






	$delta = variable_get('ristorante_default_free_date', 180);
	$data = date("d")+$delta;
	$datascad  = mktime(0, 0, 0, date("m")  , $data, date("Y"));
	$datascad = date("Y-m-d",$datascad);


	$query = "INSERT INTO {locale} (id_user,nome,comune,indirizzo,telefono,email,descrizione,menu,datains,datascad) VALUES (%d, '%s',%d,'%s','%s','%s','%s','%s','".date('Y-m-d',mktime())."','".$datascad."')";



	if(! $admin){
		$userid = $user->uid;
	}


	if(! $result = db_query($query,$userid,$nome,$comune,$indirizzo,$telefono,$email,$descrizione,$menu)){
		drupal_set_message(t("Error saving restaurant."), 'error');
		//TODO:gestione mail
		drupal_mail('restaurant','Allarmi',variable_get('site_mail', ini_get('sendmail_from')),'Errore');
		watchdog('restaurant','errore nel salvataggio del ristorante!', WATCHDOG_ERROR);
	}else{
		$id = db_last_insert_id('locale','id');
			
			
		if($id == 0){
			watchdog('restaurant','errore impossibile ottenere il codice del ristorante!', WATCHDOG_ERROR);
			drupal_set_message('errore impossibile ottenere il codice del ristorante!', 'error');
			return;
		}
			
		$directory = "./".drupal_get_path('module','ristorante').'/upload/'.$id;
			
			
		if(!file_exists($directory)){
			//Creo la directory del ristorante
			if(!@mkdir($directory,0755,true)){
				watchdog('restaurant','errore impossibile creare la cartella immagini: %cartella',array('cartella' => $directory),WATCHDOG_ERROR);
				drupal_set_message('errore impossibile creare la cartella immagini', 'error');
			}
		}else{
			watchdog('restaurant','La cartella immagini %cartella esite gi&agrave; ',array('cartella' => $directory), WATCHDOG_ERROR);
		}
			
		//Redirect alla gestione del dettaglio
		$form_state['redirect'] = 'restaurant/'.$id.'/details';
	}


}




/**
 * Gestione della ricerca un amministrazione dei ristoranti
 */
function ristorante_data_settings(){
	$form = array();
	$form['#cache'] = TRUE;

	$form['#submit'] = array('ristorante_data_settings_submit');

	$nome = '';
	$comune = '' ;
	$datascadenzada = array('year' => 1900, 'month' => 1, 'day' => 1);
	$ddata = date('Y-m-d',mktime());
	$adata = explode("-",$ddata);

	$datascadenzaa = array('year' => $adata[0] + 1, 'month' => $adata[1], 'day' => $adata[2]);


	if (isset($_SESSION['ristorante_admin_form_value'])){
		$search =  $_SESSION['ristorante_admin_form_value'];
		$nome = $search['nome'];
		$comune = $search['comune'];
		$datascadenzada = $search['datascadenzada'];
		$datascadenzaa = $search['datascadenzaa'];
	}
	 
	$form['search'] = array(
  			'#type' => 'fieldset',
  			'#title' => t('Opzioni di ricerca'),
  			'#weight' => 5,
  			'#collapsible' => TRUE,
  			'#collapsed' => FALSE
	);

	$form['search']['nome'] = array(
			'#type'	=> 'textfield',
			'#title'         => t('Nome'),
			'#value'		 => $nome,
	      	'#description'   => t('Inserisci il nome del ristorante'),
	      	'#maxlength'     => 20
	);

	$form['search']['comune'] = array(
			'#type'          => 'textfield',
      		'#title'         => t('Comune'),
      		'#description'   => t('Inserisci Comune'),
      		'#value'		 => $comune,
      		'#maxlength'     => 100,
    		'#attributes'    => array('class' => 'comuni-autocomplete'),
    		'#autocomplete_path' => 'ristorante/comune/autocomplete'
    		);

    		//Per gestire i valori array('year' => 2007, 'month' => 2, 'day' => 15)
    		$form['search']['datascadenzada'] = array(
			'#type'          => 'date',
			'#default_value' => $datascadenzada,
      		'#title'         => t('Data Scadenza da'),
      		'#description'   => t('Inserisci Data Scadenza')
    		);

    		$form['search']['datascadenzaa'] = array(
			'#type'          => 'date',
      		'#title'         => t('Data Scadenza a'),
			'#default_value' => $datascadenzaa,
      		'#description'   => t('Inserisci Data Scadenza')
    		);

    		$form['search']['buttons']['submit'] = array(
	      '#type' => 'submit',
	      '#value' => 'Filtra'
	      );
	       
	      if(isset($_SESSION['ristorante_admin_form_value'])){
	      	$form['search']['buttons']['reset'] = array(
	      		'#type' => 'submit',
	     		'#value' => 'Annulla',
	      	);
	      }

	      return $form;
}

function ristorante_data_settings_validate($form, &$form_state){
	$datascadenzada = $form_state['values']['search']['datascadenzada'];
	$datascadenzaa = $form_state['values']['search']['datascadenzaa'];

	$datada = mktime(0,0,0,$datascadenzada['month'],$datascadenzada['day'],$datascadenzada['year']);
	$dataa = mktime(0,0,0,$datascadenzaa['month'],$datascadenzaa['day'],$datascadenzaa['year']);

	if($dataa < $datada){
		form_set_error('datascadenzada', 'l\'intervallo delle date non  corretto');
	}
}

function ristorante_data_settings_submit($form, &$form_state){

	if($form_state['clicked_button']['#value'] == 'Annulla'){
		unset($_SESSION['ristorante_admin_form_value']);
		return;
	}

	$_SESSION['ristorante_admin_form_value']['nome'] =  $_POST['nome'];
	$_SESSION['ristorante_admin_form_value']['comune'] =  $_POST['comune'];
	$_SESSION['ristorante_admin_form_value']['datascadenzada'] =  $_POST['datascadenzada'];
	$_SESSION['ristorante_admin_form_value']['datascadenzaa'] =  $_POST['datascadenzaa'];

	drupal_set_message(t('Dati Filtrati.'));
}


function ristorante_admin_tabella($nome = '',$comune = '',$datascadenzada = '',$datascadenzaa = ''){
	$admin = user_access('administer users');
	$user = $GLOBALS['user'];

	$query = "SELECT l.nome as nome,c.comune as comune,l.indirizzo as indirizzo,l.telefono as telefono,l.email as email,l.datascad as datascadenza,l.datains as datainserimento,l.dataagg as dataaggiornamento,l.id as id FROM {locale} l INNER JOIN {comune} c ON l.comune = c.id WHERE 1=1";

	//Filtro dati per utente
	if(! $admin){
		$query .= sprintf(" AND l.id_user = %d",$user->uid);
	}

	//Filtro dati per nome
	if($nome != ''){
		$query .=sprintf(" AND LOWER(l.nome) LIKE '%s",db_escape_string(strtolower($nome)));
		$query .="%'";
	}

	//Filtro dati per comune
	if($comune != ''){
		$query .= ' AND LOWER(c.comune) = \''.db_escape_string(strtolower($comune)).'\'';
	}

	//Filtro dati per data
	if($datascadenzada != '' && $datascadenzaa != ''){
		$da = $datascadenzada['year']. '-' . $datascadenzada['month'] . '-' . $datascadenzada['day'];
		$a = $datascadenzaa['year']. '-' . $datascadenzaa['month'] . '-' . $datascadenzaa['day'];
		$query .= ' AND l.datascad BETWEEN  \''.db_escape_string(strtolower($da)).'\' AND ' . '\''.db_escape_string(strtolower($a)).'\'';
	}
	if($admin){
		$header = array('nome','comune','indirizzo','telefono','email','data scadenza','data inserimento','data aggiornamento','operazioni');
	}else{
		$header = array('nome','comune','indirizzo','telefono','email','data scadenza','data inserimento','operazioni');
	}
	$q = pager_query($query, 25);
	$data = array();

	while($res = db_fetch_array($q)) {
			
			
		$datascadenza = $res['datascadenza'];
		$datascadenza = date("d/m/Y",strtotime($datascadenza));
			
			
		$datainserimento = $res['datainserimento'];
		$datainserimento = date("d/m/Y",strtotime($datainserimento));
			
		$dataaggiornamento = format_date(strtotime($res['dataaggiornamento']),'small');
			
		$operazioni = l("Cancella","/restaurant/".$res['id']."/delete",array('attributes' => array('onclick' => 'return confirm(\'Sei sicuro di voler cancellare il ristorante : '.$res['nome'].' \');')));
			
		if($admin){
			$data[] = array($res['nome'],$res['comune'],$res['indirizzo'],$res['telefono'],$res['email'],$datascadenza,$datainserimento,$dataaggiornamento,$operazioni);
		}else{
			$data[] = array($res['nome'],$res['comune'],$res['indirizzo'],$res['telefono'],$res['email'],$datascadenza,$datainserimento,$operazioni);
		}
	}



	return theme('table', $header, $data);
}


function getRoles(){
	$roles = user_roles(TRUE);
	return $roles;
}

function getThemes(){
	$themes = list_themes(FALSE);
	$value = array();
	foreach ($themes as $theme){
		$name = $theme->name;
		$value[$name] = $name;
	}


	return $value;
}


function ristorante_admin_settings_validate($form, &$form_state){
	$free = $form_state['values']['free_date'];


	if(!preg_match("/[0-9]+/",$form_state['values']['free_date'])){
		form_set_error('free_date', t('Inserire un numero valido'));
	}
}

function ristorante_admin_settings_submit($form, &$form_state){
	$role = $form_state['values']['role'];
	$theme = $form_state['values']['theme'];

	$free = $form_state['values']['free_date'];


	variable_set('ristorante_default_theme',$theme);
	variable_set('ristorante_user_role',$role);
	variable_set('ristorante_default_free_date',$free);

	drupal_set_message(t("Impostazioni Salvate"));
}
?>