<?php

/**
 * Funzione di utilit per immagini
 */
function get_full_path_to_theme() {
	return base_path().path_to_theme();
}


/**
 * Funzione di ingresso per il modulo di ricerca esposto al pubblico
 */
function ristorante_search_page(){
	//print_r($_SESSION); //Se la sessione non dovesse funzionare creare un utente con ID 0 http://drupal.org/node/360542
	$data = "<div class='italia'><img src='".get_full_path_to_theme()."/images/italia.jpg' alt=\"immagine italia\"/></div>";
	$data .= drupal_get_form('ristorante_search_form');
	if(isset($_SESSION['ristorante_form_valid']) && $_SESSION['ristorante_form_valid'] == true){
		$comune = $_SESSION['ristorante_form_value']['comuni'];
		$provincia = $_SESSION['ristorante_form_value']['provincie'];
		$specialita = $_SESSION['ristorante_form_value']['specialita'];
		$data .= ristorante_tabella($specialita,$comune,$provincia);
	}
	return $data;
}


function ristorante_data_page($ristorante){

	
	
	$query = db_query( sprintf("SELECT l.nome as nome,c.comune as comune,l.indirizzo as indirizzo,l.telefono as telefono,l.email as email,l.descrizione as descrizione,l.menu as menu FROM {locale} l INNER JOIN {comune} c ON l.comune = c.id WHERE l.id = %d",$ristorante));
	$res = db_fetch_array($query);
	
	
	$data = "<div><span class='ristorante-title'>Nome: </span>".$res[nome]."</div>";
	$data .= "<div><span class='ristorante-title'>Comune: </span>".$res[comune]."</div>";
	$data .= "<div><span class='ristorante-title'>Indirizzo: </span>".$res[indirizzo]."</div>";
	$data .= "<div><span class='ristorante-title'>Telefono: </span>".$res[telefono]."</div>";
	$data .= "<div><span class='ristorante-title'>Email: </span>".$res[email]."</div>";
	$data .= "<div><div class='ristorante-title'>Descrizione: </div>".$res[descrizione]."</div>";
	
	$data .= "<hr/>";
	
	$data .= "<div><a target='_blank' href='http://maps.google.com/maps?f=q&source=s_q&hl=it&geocode=&q=".$res[indirizzo].",".$res[comune]."'><img src='".base_path()."/".drupal_get_path('theme','ristoclick')."/images/gmap-icon.jpg'/ alt='Geolocalizza' title='Posiziona su gmaps'></a></div>";
	
	$data .="<div><p>".$res[menu]."</p></div>";
	
	
	$header = array(
		array(
	      'data'  => t('Nome'),
	      'field' => 'nome',
	      'sort'  => 'desc',
		),
		array(
	      'data'  => t('Descrizione'),
	      'field' => 'descrizione'
		)
	);
	
	
	$query = sprintf("SELECT s.nome AS nome, l.descrizione AS descrizione FROM {localespecialita} l INNER JOIN {specialita} s ON l.specialita = s.id WHERE l.locale = %d",$ristorante);
	
	
	$query .= tablesort_sql($header);
	$q = pager_query($query, 25);
	
	
	
	$spec = array();
	while($res = db_fetch_array($q)) {
		$spec[] = $res;
	}
	
	
	$data .= theme('table', $header, $spec);
	$data .= theme('pager', NULL, 25, 0);
	
	$query = sprintf("SELECT image as immagine,descrizione FROM {localeimage} WHERE locale = %d",$ristorante);
	$img =  db_query($query);
	
	$data .= "<div>";
	$data .= "<div class='ristorante-title'>Foto</div>";
	$data .= "<span class=\"inline inline-left\">";
	while($rows = db_fetch_array($img)) {
		 $data .= "<a href='".base_path()."/".drupal_get_path('module','ristorante').'/upload/'.$ristorante.'/'.$rows['immagine']."' rel=\"lightbox[ristoranti][".$ristorante."]\"><img class='ristorante-gallery' src=\"".base_path()."/".drupal_get_path('module','ristorante').'/upload/'.$ristorante.'/'.$rows['immagine']."\" alt=\"".$rows['descrizione']." \" width='100px'/></a>";
	}
	$data .= "</span>";
	$data .= "</div>";
	return $data;
}


/**
 * Gestione tabella ristoranti
 * @param int $specialita
 * @param string $comune
 */
function ristorante_tabella($specialita=0,$comune='',$provincia=0){
		$query = "SELECT DISTINCT l.nome as nome,c.comune as comune,l.indirizzo as indirizzo,l.telefono as telefono,l.email as email,l.descrizione AS descrizione,l.id as id FROM {locale} l LEFT JOIN {comune} c ON l.comune = c.id LEFT JOIN {localespecialita} s ON s.locale = l.id WHERE 1";
		
		if($comune != ''){
			$query .= ' AND LOWER(c.comune) = \''.db_escape_string(strtolower($comune)).'\'';
		}else if($provincia != 0){
			$query .= sprintf(' AND c.provincia = %d',$provincia);
		}
		
		if($specialita != 0){
			$query .= sprintf(' AND s.specialita = %d',$specialita);
		}	
		
		//drupal_set_message($query);
		
		$q = pager_query($query, 25);
		$data = array();
		while($res = db_fetch_array($q)) {
			$q1 = sprintf("SELECT image as immagine,descrizione FROM {localeimage} WHERE locale = %d ORDER BY id LIMIT 0,1",$res['id']);
			
			$output .= "<div class=\"listabox\">";
			if($res1 = db_fetch_array(db_query($q1))){
				$output .= "<div class='image-box'><img src=\"".base_path()."/".drupal_get_path('module','ristorante').'/upload/'.$res['id'].'/'.$res1['immagine']."\" alt=\"".$res1['descrizione']." \" width='100px'/></div>";
			}else{
				//Non esitono ancora immagini
				$output .= "<div class='image-box'><img src=\"".base_path()."/".drupal_get_path('module','ristorante')."/images/empty.jpg\" alt=\"Immagine di esempio\" width=\"100px\"/></div>";
			}
			$output .= "<h3 class=\"aranciob\">";
			$output .= l($res['nome'],'restaurant/'.$res['id'],array("attributes" => array("class"=>"aranciob")));
			$output .= "</h3>";
			$output .= "<div>";
			$output .= $res['indirizzo']." ".$res['comune'];
			$output .= "</div>";
			$output .= "<div class=\"listasep\">";
			$output .= "<b>Telefono</b> ".$res['telefono'];
			$output .= "</div>";
			$output .= "<p>";
			$output .= $res['descrizione'];
			$output .= "</p>";
			
			/*Barra strumenti*/
			$output .= "<div class=\"lista_menu\"><ul>";
			$output .= "<li>".l("scheda",'restaurant/'.$res['id'])." | </li>";
			if(isset($res['email']) && $res['email'] != '')
				$output .= "<li><a href='mailto:".$res['email']."'>email</a> | </li>";
		
			$output .= "<li><a target='_blank' href='http://maps.google.com/maps?f=q&source=s_q&hl=it&geocode=&q=".$res[indirizzo].",".$res[comune]."'>gmaps</a></li>";
			$output .= "</ul>";
			$output .= "</div>";
			$output .= "</div>";
			
		}
			
		$output .= theme('pager', NULL, 25, 0);
		return $output;
}




/**
 * Parte Creazione Form FAPI
 * @param array $form_state valori del post del form
 * @param array $ajax_values valori ajax di rimpiazzo se manca il javascript
 * @return form
 */
function ristorante_search_form(&$form_state, $ajax_values = array()) {
	$form = array();
	$form['#cache'] = TRUE;
	$form['#submit'] = array('ristorante_form_submit');

	//Gestione autocomplete
	drupal_add_js(drupal_get_path('module','ristorante').'/js/script.js');

	if (isset($form_state['ajax_values'])) {
		$ajax_values = $form_state['ajax_values'] + (array)$ajax_values;
	}


	$options_regioni = _ristorante_search_regioni();
	
	$selected_regioni = 0;
	if(isset($ajax_values['regione'])){
		$selected_regioni = $ajax_values['regione'];
	}else if(isset($_SESSION['ristorante_form_value']['regione'])){
		$selected_regioni = $_SESSION['ristorante_form_value']['regione'];
	}else{
		$selected_regioni = key($options_regioni);
	}
	
	$form['regione'] = array(
      	'#type' => 'select',
      	'#title' => t('Regione'),
    	'#options' => $options_regioni,
    	'#default_value' => $selected_regioni,
    	'#ahah' => array(
      		'path' => 'ristorante/regione/callback',
      		'wrapper' => 'dropdown-provincie'
      	)
      );

      //Bottone di rimpiazzo se manca il js
      $form['continue_to_second'] = array(
      	'#type' => 'submit',
     	 '#value' => t('Scegli'),
      	'#attributes' => array('class' => 'next-button'),
      	'#submit' => array('ristorante_submit_handler'),
      );

      $form['dropdown_provincie_wrapper'] = array(
      	'#tree' => TRUE,
      	'#prefix' => '<div id="dropdown-provincie">',
      	'#suffix' => '</div>',
      	);

      	
      	$options_provincie = _ristorante_search_provincie($selected_regioni);
      	$selected_provincie = 0;
		if(isset($ajax_values['provincie'])){
			$selected_provincie = $ajax_values['provincie'];
		}else if(isset($_SESSION['ristorante_form_value']['provincie'])){
			$selected_provincie = $_SESSION['ristorante_form_value']['provincie'];
		}else{
			$selected_provincie = key($options_provincie);
		}

      $form['dropdown_provincie_wrapper']['provincie'] = array(
      	'#type' => 'select',
      	'#title' => t('Province'),
    	'#options' => $options_provincie,
    	'#default_value' => $selected_provincie,
      );

      $value_comuni = ''; 
      if(isset($_SESSION['ristorante_form_value']['comuni'])){
      	$value_comuni = $_SESSION['ristorante_form_value']['comuni'];
      }
      //Autocompletamento comune
      $form['comuni'] = array(
    	'#type'          => 'textfield',
      	'#title'         => t('Comune'),
      	'#description'   => t('Inserisci Comune'),
      	'#value'		 => $value_comuni,
      	'#maxlength'     => 100,
    	'#attributes'    => array('class' => 'comuni-autocomplete'),
    	'#autocomplete_path' => 'ristorante/comune/autocomplete'
    	);

    	$selected_specialita = 0;
		if(isset($_SESSION['ristorante_form_value']['specialita'])){
      		$selected_specialita = $_SESSION['ristorante_form_value']['specialita'];
      	}
    	
	    //Scelta delle specialita
	    $form['specialita'] = array(
	    	'#type' => 'select',
	      	'#title' => t('Specialit&agrave;'),
	    	'#options' => _ristorante_search_specialita(),
	    	'#default_value' => $selected_specialita
	    );


	    $form['buttons']['submit'] = array(
	      '#type' => 'submit',
	      '#value' => 'Cerca',
	    );
	    
	    if(isset($_SESSION['ristorante_form_valid'])){
	    	$form['buttons']['reset'] = array(
	      		'#type' => 'submit',
	     		'#value' => 'Annulla',
	    	);
	    }
	    return $form;
}

/**
 * Hook per il submit
 * @param $form
 * @param $form_state
 */
function ristorante_form_submit($form, &$form_state) {
	if ($form_state['clicked_button']['#id'] == 'edit-submit') {
		$form_state['rebuild'] = FALSE;
		
		$values = $form_state['values'];
		$query = "SELECT COUNT(l.nome) as data FROM {locale} l LEFT JOIN {comune} c ON l.comune = c.id LEFT JOIN {localespecialita} s ON s.locale = l.id WHERE 1";
		if($_POST['comuni'] != ''){
			$query .= ' AND LOWER(c.comune) = \''.db_escape_string(strtolower($_POST['comuni'])).'\'';
		}else if($values['provincia'] != 0){
			$query .= sprintf(' AND c.provincia = %d',$values['provincia']);
		}
		
		if($values['specialita'] != 0){
			$query .= sprintf(' AND s.specialita = %d',$values['specialita']);
		}	
		
		$data =  db_query($query);
		
		$rows = db_fetch_array($data);
	
		
		if($rows['data'] == 0){
			drupal_set_message(t("Nessun risultato"));
			$_SESSION['ristorante_form_valid'] = false;
		}else{
			$_SESSION['ristorante_form_valid'] = true;
		}
		$_SESSION['ristorante_form_value']['regione'] = $values['regione'];
		$_SESSION['ristorante_form_value']['provincie'] = $values['dropdown_provincie_wrapper']['provincie'];
		//Uso il post perch non viene caricato nello state :(
		$_SESSION['ristorante_form_value']['comuni'] = $_POST['comuni'];
		$_SESSION['ristorante_form_value']['specialita'] = $values['specialita'];
		//print_r($_SESSION);
		return;
	}else if($form_state['clicked_button']['#id'] == 'edit-reset'){
		unset($_SESSION['ristorante_form_valid']);
		$_SESSION['ristorante_form_value'] = array();
	}
	
	$form_state['rebuild'] = TRUE;
}


//Handler per la gestione delle provincie usato nelle chiamate ajax
function ristorante_submit_handler($form, &$form_state) {
	$values = $form_state['values'];
	unset($form_state['submit_handlers']);
	form_execute_handlers('submit', $form, $form_state);
	$form_state['ajax_values'] = $values;
	$form_state['rebuild'] = TRUE;
}

/**
 * Funzione di utilit per scaricare le regioni dal db
 */
function _ristorante_search_regioni(){
	$options = array();
	$rows = db_query("SELECT id, nome FROM {regione}");
	$options[0] = "Tutte le regioni";
	while ($row = db_fetch_array($rows)) {
		$options[$row['id']] = $row['nome'];
	}
	return $options;
}

/**
 * Funzione di utilit per scaricare le provincie dal db
 */
function _ristorante_search_provincie($selected){
	$options = array();
	$rows =  db_query("SELECT id, provincia FROM {provincia} where regione = %d",$selected);
	$options[0] = "Tutte le province";
	while ($row = db_fetch_array($rows)) {
		$options[$row['id']] = $row['provincia'];
	}
	return $options;
}

/**
 * Funzione di utilit per scaricare le specialit dal db
 */
function _ristorante_search_specialita(){
	$options = array();
	$rows =  db_query("SELECT id, nome FROM {specialita} order by id");
	$options[0] = "Tutte";
	while ($row = db_fetch_array($rows)) {
		$options[$row['id']] = $row['nome'];
	}
	return $options;
}

/**
 * Funzione di callback per l'autocompletamento delle provincie
 */
function ristorante_regione_callback() {
	$form_state = array('storage' => NULL, 'submitted' => FALSE);
	$form_build_id = $_POST['form_build_id'];
	$form = form_get_cache($form_build_id, $form_state);

	$args = $form['#parameters'];
	$form_id = array_shift($args);
	$form_state['post'] = $form['#post'] = $_POST;
	$form['#programmed'] = $form['#redirect'] = FALSE;

	drupal_process_form($form_id, $form, $form_state);
	$form = drupal_rebuild_form($form_id, $form_state, $args, $form_build_id);
	$changed_elements = $form['dropdown_provincie_wrapper'];

	unset($changed_elements['#prefix'], $changed_elements['#suffix']); // Prevent duplicate wrappers.

	drupal_json(array(
    'status'   => TRUE,
    'data'     => theme('status_messages') . drupal_render($changed_elements),
	));
}

/**
 * Funzione per l'autocompletamento dei comuni
 * @param $string
 * @param $provincia
 * @param $regione
 * @param $id
 */
function ristorante_comune_autocomplete($string, $provincia = 0, $regione = 0,$id=''){
	$data = array();


	$select = "SELECT c.comune as comune,p.provincia as provincia FROM {comune} c INNER JOIN {provincia} p ON c.provincia = p.id WHERE 1=1 ";

	if($provincia != 0){
		$select .=sprintf(" AND c.provincia = %d",$provincia);
	}else if($regione != 0){
		$select .=sprintf(" AND p.regione = %d",$regione);
	}

	$select .=sprintf(" AND LOWER(comune) LIKE '%s",db_escape_string(strtolower($string)));
	$select .="%'";
	$select .=" LIMIT 0 , 30";
	$result = db_query($select);

	while ($row = db_fetch_array($result)) {
		$data[$row['comune']] = $row['comune']. " (" .$row['provincia'].")";
	}

	return drupal_json($data);
}
?>